using System.ComponentModel;
using System.Runtime.CompilerServices;
using System.Windows.Controls;

namespace Compdfkit_Tools.DigitalSignature.VerifyDigitalSignatureControl
{
    public partial class SignerInfoControl : UserControl, INotifyPropertyChanged
    {
        private string _signerInfoString;
        public string SignerInfoString
        {
            get => _signerInfoString;
            set => UpdateProper(ref _signerInfoString, value);
        }
        
        public SignerInfoControl()
        {
            InitializeComponent();
        }
        
        public event PropertyChangedEventHandler PropertyChanged;

        protected void UpdateProper<T>(ref T properValue,
            T newValue,
            [CallerMemberName] string properName = "")
        {
            if (object.Equals(properValue, newValue))
                return;

            properValue = newValue;
            OnPropertyChanged(properName);
        }

        protected void OnPropertyChanged([CallerMemberName] string propertyName = "") =>
            PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(propertyName));
    }
}